
clear;
m=4; n=6;
r = [3;2;3;4];
s = [3;2;2;3;1;1];

[flag,flow,matrix ] = zeroone( m,n,r,s );

disp(flow);
disp(matrix);


function [ flag,max_flow,matrix ] = zeroone( m,n,r,s )
    nodes_number = 1 + 1 + m + n;
    source = 1;
    sink = nodes_number;
    capacity = zeros(nodes_number,nodes_number);
    capacity(1,2:m+1) = r';
    capacity(m+2:m+n+1,end) = s;
    capacity(2:m+1,m+2:m+n+1) = 1;

    [max_flow,path_mat] = ff_max_flow(source,sink,capacity,nodes_number);
    if sum(r) ~= sum(s)
        flag = 'No!';
        disp(flag);
        matrix = [];
    elseif max_flow == sum(r)
            row = path_mat(:,1)-1;
            col = path_mat(:,2)-m-1;
            matrix = sparse(row,col,ones(size(path_mat,1),1),m,n);
            matrix = full(matrix);
            flag = 'Yes!';
            disp(flag);
            % disp(matrix);
    else
        flag = 'No!';
        disp(flag);
        matrix = [];
    end
end

%WHITE =0;
%GRAY=1;
%BLACK=2

function [final_augmentpath, augmentpath]=bfs_augmentpath(start,target,current_flow,capacity,n)
    WHITE =0;
    GRAY=1;
    BLACK=2;
    color(1:n)=WHITE;
    head=1;
    tail=1;
    q=[];
    augmentpath=[];
    final_augmentpath = [];
    %ENQUEUE
    q=[start q];
    color(start)=GRAY;
    pred=zeros(1,n);
    while ~isempty (q)
    %    [u,q]=dequeue(q);
            u=q(end);
            q(end)=[];
            color(u)=BLACK;
    %     dequeue end here

            for v=1:n
                if (color(v)==WHITE && capacity(u,v)>current_flow(u,v) )
    % enqueue(v,q)
                    q=[v q];
                    color(v)=GRAY;
    % enqueue end here
                    pred(v)=u;
                end
            end
    end
    if color(target)==BLACK       %if target is accessible
       temp=target;
       while pred(temp)~=start
        augmentpath = [pred(temp) augmentpath];     %augment path doesnt containt the start point AND target point
        temp=pred(temp);
       end
       final_augmentpath=[start augmentpath target];
    else
        final_augmentpath=[];         % default result is empty
    end
end




function [max_flow,path_mat]=ff_max_flow(source,sink,capacity,nodes_number)

current_flow=zeros(nodes_number,nodes_number);
max_flow=0;
path_mat=[];
temp = bfs_augmentpath(source,sink,current_flow,capacity,nodes_number);
%bfs_augmentpath(2,6,current_flow,capacity,6)

while ~isempty(temp)
    % if there exits a augment path, update teh current_flow
    increment = inf;
    for i=1:length(temp)-1
        increment=min(increment, capacity(temp(i),temp(i+1))-current_flow(temp(i),temp(i+1)));
    end
    %now increase the current_flow
    for i=1:length(temp)-1
        current_flow(temp(i),temp(i+1))=current_flow(temp(i),temp(i+1))+increment;
        current_flow(temp(i+1),temp(i))=current_flow(temp(i+1),temp(i))-increment;
    end
    max_flow=max_flow+increment;
    [temp,augmentpath] = bfs_augmentpath(source,sink,current_flow,capacity,nodes_number);% try to find new augment path
    for i=1:2:size(augmentpath,2)
        path_mat = [path_mat; augmentpath(1,i:i+1)];
    end
end



function [new_graph, new_weight,cap] = update_graph(A,W,temp)
    % cap = min([W(path(1),path(2)) W(path(2),path(3)) W(path(3),path(4))]);
    len_p = size(temp,2);
    cap = W(temp(1),temp(2));
    for i = 2:len_p-1
        if W(temp(i),temp(i+1)) < cap
            cap = W(temp(i),temp(i+1));
        end
    end

    for i = 1:len_p-1
        W(temp(i),temp(i+1)) = W(temp(i),temp(i+1)) - cap;
        W(temp(i+1),temp(i)) = W(temp(i+1),temp(i)) + cap;
        if W(temp(i),temp(i+1)) == 0
            A(temp(i),temp(i+1)) = 0;
        end
        if W(temp(i+1),temp(i)) == 0
            A(temp(i+1),temp(i)) = 0;
        else
            A(temp(i+1),temp(i)) = 1;
        end
    end

    new_graph = A;
    new_weight = W;
end
end

